From 6526398469abead1dcbb790310c69c7bf1c512af Mon Sep 17 00:00:00 2001
From: Starwer <starwer@laposte.net>
Date: Sun, 8 Mar 2015 11:46:50 +0100
Subject: [PATCH] - Bugfix: ExternalProgram modifies wrong textbox when using
 StartFolder selector - Bugfix: use of \ at the end of a command parameter was
 inconsistent

---
 IR Server Suite/Common/IrssUtils/Common.cs         | 28 +++++++++++++++++++++-
 .../Common/IrssUtils/Forms/ExternalProgram.cs      |  2 +-
 2 files changed, 28 insertions(+), 2 deletions(-)

diff --git a/IR Server Suite/Common/IrssUtils/Common.cs b/IR Server Suite/Common/IrssUtils/Common.cs
index 1908ecd..0f5525f 100644
--- a/IR Server Suite/Common/IrssUtils/Common.cs	
+++ b/IR Server Suite/Common/IrssUtils/Common.cs	
@@ -570,7 +570,23 @@ namespace IrssUtils
         /// <returns>Returns string[] of command elements.</returns>
         private static string[] SplitCommand(string command, int elements)
         {
-      if (String.IsNullOrEmpty(command))
+            if (String.IsNullOrEmpty(command))
+                throw new ArgumentNullException("command");
+
+            string[] commands = command.Split(new Char [] {'|'});
+
+            if (elements == 0 || commands.Length != elements)
+            {
+                if (command != "")
+                    throw new CommandStructureException(String.Format("Command structure does not split as expected: {0}", command));
+                return null;
+            }
+
+            return commands;
+
+            /** This alternative code allows to use the | character in the commands but is disabled for backward-compatibility **
+
+            if (String.IsNullOrEmpty(command))
                 throw new ArgumentNullException("command");
 
             if (elements == 0)
@@ -626,6 +642,7 @@ namespace IrssUtils
                 throw new CommandStructureException(String.Format("Command structure does not split as expected: {0}", command));
 
             return commands;
+            */
         }
 
 
@@ -638,6 +655,13 @@ namespace IrssUtils
         {
             if (command == null) return "";
 
+            return String.Join("|", command);
+            
+            
+            /** This alternative code allows to use the | character in the commands but is disabled for backward-compatibility **
+            if (command == null) return "";
+
+
             // first estimated length, defined by rule of thumbs
             StringBuilder commands = new StringBuilder(256);
 
@@ -675,6 +699,8 @@ namespace IrssUtils
                 started = true;
             }
             return commands.ToString();
+
+            */
         }
 
         #endregion Command Splitters
diff --git a/IR Server Suite/Common/IrssUtils/Forms/ExternalProgram.cs b/IR Server Suite/Common/IrssUtils/Forms/ExternalProgram.cs
index acf195d..c0ceb08 100644
--- a/IR Server Suite/Common/IrssUtils/Forms/ExternalProgram.cs	
+++ b/IR Server Suite/Common/IrssUtils/Forms/ExternalProgram.cs	
@@ -187,7 +187,7 @@ namespace IrssUtils.Forms
     {
       if (folderBrowserDialog.ShowDialog(this) == DialogResult.OK)
       {
-        textBoxProgram.Text = folderBrowserDialog.SelectedPath;
+          textBoxStartup.Text = folderBrowserDialog.SelectedPath;
       }
     }
 
-- 
1.9.5.msysgit.0

